/// <reference types="node" resolution-mode="require"/>
export declare type Options = {
    verbose: boolean | number;
    cwd: string;
    env: NodeJS.ProcessEnv;
    prefix: string;
    shell: string;
    maxBuffer: number;
    quote: (v: string) => string;
    logOutput?: 'stdout' | 'stderr';
    logFormat?: (...msg: any[]) => string | string[];
    logPrint?: (data: any, err?: any) => void;
    logIgnore?: string | string[];
};
export declare type Context = Options & {
    nothrow?: boolean;
    cmd: string;
    __from: string;
    resolve: any;
    reject: any;
};
export declare function getCtx(): Context;
export declare function setRootCtx(ctx: Options): void;
export declare function getRootCtx(): Options;
export declare const runInCtx: <R, TArgs extends any[]>(store: Options, callback: (...args: TArgs) => R, ...args: TArgs) => R;
